% FLAT_Flow_out Function
% use this function if the cell is Flat to check if there is a flow out
% from Flat region
% Author: Abdulghani Hasan,  Date: 10/2010

function [FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,Check_Matrix]=FLAT_Flow_out(FP1,FP2,FP3,FP4,FP5,FP6,FP7,FP8,Classification_matrix,Check_Matrix,ZT,nrows,ncols)
%coordinates and numbering a 3*3 window cells
    %-------------------------
    %| 8  |   1   |   2   |
    %| 7  |   10  |   3   |
    %| 6  |   5   |   4   |
    %-------------------------
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 %[tr,tc]=find(Check_Matrix ==0);
 Check_MatrixF=zeros(nrows,ncols); %check matrix for flat cells
 Check_MatrixF(Classification_matrix==3)=1;
 FL = bwlabel(Check_MatrixF);
MAXFLAT=max(max(FL));
 %Check_Matrix = imcomplement(Check_Matrix);
%[n,trash]=size(tr); %find n the size of that matrix

% matrix the numbers in this matrix will be change acording to the number
%of cell with defined flow path around each cell.
%cellsleft=sum(sum(Check_Matrix ==0))

    %end of number of neighbors calculations
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for kk=1:MAXFLAT %Go through all flat cells
    [tr,tc]=find(FL ==kk);
    [n,trash]=size(tr); %find n the size of that matrix
    remain_flat_areas=MAXFLAT-kk
    
    

nn=0;
    Remain_cell=n;         
%put all cells aorund this cell in a matrix and do the same for all 8
%directions 
Label=1;
while Remain_cell>0
    
for k=1:n
if Check_Matrix(tr(k),tc(k)) == 0 ...
 && tr(k)>2 && tc(k)>2 && tr(k)<(nrows-1) && tc(k)<(ncols-1) %excluding the boundary cells
%  if tr(k)>1 && tc(k)>1 && tr(k)<nrows && tc(k)< ncols && Check_Matrix(tr(k),tc(k))==0 %excluding the boundary cells
 
     %to find the boundary of current cell
  Cell8=Check_Matrix(tr(k)-1,tc(k)-1); Cell1=Check_Matrix(tr(k)-1,tc(k)); Cell2=Check_Matrix(tr(k)-1,tc(k)+1);...
            Cell3=Check_Matrix(tr(k),tc(k)+1);Cell4=Check_Matrix(tr(k)+1,tc(k)+1);...
            Cell5=Check_Matrix(tr(k)+1,tc(k)); Cell6=Check_Matrix(tr(k)+1,tc(k)-1); Cell7=Check_Matrix(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix with correct coordinates
    %according to the new 3 * 3 window cell sequance
    Check_boundary=[ Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8 ];  
     
    %for elevation matrix
    Cell8=ZT(tr(k)-1,tc(k)-1); Cell1=ZT(tr(k)-1,tc(k)); Cell2=ZT(tr(k)-1,tc(k)+1);...
            Cell3=ZT(tr(k),tc(k)+1);Cell4=ZT(tr(k)+1,tc(k)+1);...
            Cell5=ZT(tr(k)+1,tc(k)); Cell6=ZT(tr(k)+1,tc(k)-1); Cell7=ZT(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    ZT_boundary=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];  
    
        
    
    idxfLB=find(Check_boundary==Label); %find indexes of done cellss
     lng=length(idxfLB); %find the number of done cells around current cell
     
    %search for the way out between already checked cells
     FB=0;
     while FB<lng
         FB=FB+1;
        s=idxfLB(FB); %find the direction of that index, go through done cells
     if ZT(tr(k),tc(k)) >= ZT_boundary(s)% && Check_Matrix(tr(k),tc(k))==0;%ckecking the ckeck matrix is not needed  
      if  s==8
           rn=-1; cn=-1;
   elseif s==1
           rn=-1; cn=0;
   elseif s==2
           rn=-1; cn=+1;           
   elseif s==3
            rn=0; cn=+1;     
   elseif s==4
            rn=+1; cn=+1;   
   elseif s==5
            rn=+1; cn=0;         
   elseif s==6
            rn=+1; cn=-1;          
   elseif s==7
            rn=0; cn=-1;  
      end
        
  Cell82=FP1(tr(k)+rn,tc(k)+cn); Cell12=FP2(tr(k)+rn,tc(k)+cn); Cell22=FP3(tr(k)+rn,tc(k)+cn);...
            Cell32=FP4(tr(k)+rn,tc(k)+cn);Cell42=FP5(tr(k)+rn,tc(k)+cn);...
            Cell52=FP6(tr(k)+rn,tc(k)+cn); Cell62=FP7(tr(k)+rn,tc(k)+cn); Cell72=FP8(tr(k)+rn,tc(k)+cn);
    %Putting all 8 cells in a vector matrix
    FPCellsmat2=[Cell12; Cell22; Cell32; Cell42; Cell52; Cell62; Cell72; Cell82 ];
        
    Cell8=Check_Matrix(tr(k)+(rn-1),tc(k)+(cn-1)); Cell1=Check_Matrix(tr(k)+(rn-1),tc(k)+(cn)); Cell2=Check_Matrix(tr(k)+(rn-1),tc(k)+(cn+1));...
            Cell3=Check_Matrix(tr(k)+(rn),tc(k)+(cn+1)); Cell4=Check_Matrix(tr(k)+(rn+1),tc(k)+(cn+1));...
            Cell5=Check_Matrix(tr(k)+(rn+1),tc(k)+(cn)); Cell6=Check_Matrix(tr(k)+(rn+1),tc(k)+(cn-1)); Cell7=Check_Matrix(tr(k)+(rn),tc(k)+(cn-1));
    %Putting all 8 cells in a vector matrix
    Cellsmat2=[ Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];
  
    Cell8=FL(tr(k)+(rn-1),tc(k)+(cn-1)); Cell1=FL(tr(k)+(rn-1),tc(k)+(cn)); Cell2=FL(tr(k)+(rn-1),tc(k)+(cn+1));...
            Cell3=FL(tr(k)+(rn),tc(k)+(cn+1)); Cell4=FL(tr(k)+(rn+1),tc(k)+(cn+1));...
            Cell5=FL(tr(k)+(rn+1),tc(k)+(cn)); Cell6=FL(tr(k)+(rn+1),tc(k)+(cn-1)); Cell7=FL(tr(k)+(rn),tc(k)+(cn-1));
    %Putting all 8 cells in a vector matrix
    CellsmatFL2=[ Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8 ];
  
    skip=0;  
        FPtemp=zeros(8,1);
       idxfp=find(FPCellsmat2>0);
    leng=length(idxfp);
    for fp=1:leng
        if Cellsmat2(idxfp(fp))==0;%%flow to another flat cell
         skip=1;   
        if CellsmatFL2(idxfp(fp))~=kk;%flow to another flat cell but in different flat region
         skip=0;   
        end
        end
                
    end
    
%     if tr(k)==25 && tc(k)==44
%      skip
%      pause
%     end
       
    
      if skip==0  
   %identify the  the index of the cell 
          FPtemp(s)=100;  
    %give the calculated flowpath values in FPtemp to the correct matrix 
    FP1(tr(k),tc(k))=FPtemp(1);
    FP2(tr(k),tc(k))=FPtemp(2);
    FP3(tr(k),tc(k))=FPtemp(3);
    FP4(tr(k),tc(k))=FPtemp(4);
    FP5(tr(k),tc(k))=FPtemp(5);
    FP6(tr(k),tc(k))=FPtemp(6);
    FP7(tr(k),tc(k))=FPtemp(7);
    FP8(tr(k),tc(k))=FPtemp(8); 
      %check the matrix as done     
    Check_Matrix(tr(k),tc(k))=Label+1;
    Check_MatrixF(tr(k),tc(k))=0;
    Remain_cell=Remain_cell - 1  ;
    FB=lng;
     
          
      end
     end 
     end % end of while
 

    

  
 end % end if 
end %end for k:n
nnn=nn-Remain_cell;
    if nnn == 0
       Remain_cell=0;
    end
Label=Label+1;
nn=Remain_cell;
end %end while remain

end %end kk
kk

%To asign flow direction to unchecked flat cells near the bourder
%%
%this is for flat cells near the border and not the unclassified unchecked
%border cells


%%%
skiphere=0; %this is to skip the rest
if skiphere==0
[tr,tc]=find(Check_MatrixF ==1) %what remain from above flow distribution
[n,trash]=size(tr); %find n the size of that matrix
nn=0;
Remain_cell2=n;
while Remain_cell2>0
for k=1:n
 if Check_Matrix(tr(k),tc(k)) ==0 && Classification_matrix(tr(k),tc(k))==3
     tr(k)
     tc(k)
    Cell8=Check_Matrix(tr(k)-1,tc(k)-1); Cell1=Check_Matrix(tr(k)-1,tc(k)); Cell2=Check_Matrix(tr(k)-1,tc(k)+1);...
            Cell3=Check_Matrix(tr(k),tc(k)+1);Cell4=Check_Matrix(tr(k)+1,tc(k)+1);...
            Cell5=Check_Matrix(tr(k)+1,tc(k)); Cell6=Check_Matrix(tr(k)+1,tc(k)-1); Cell7=Check_Matrix(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    Check_boundary=[ Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8] ;
    
    Cell8=ZT(tr(k)-1,tc(k)-1); Cell1=ZT(tr(k)-1,tc(k)); Cell2=ZT(tr(k)-1,tc(k)+1);...
            Cell3=ZT(tr(k),tc(k)+1);Cell4=ZT(tr(k)+1,tc(k)+1);...
            Cell5=ZT(tr(k)+1,tc(k)); Cell6=ZT(tr(k)+1,tc(k)-1); Cell7=ZT(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    ZT_boundary=[ Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];
   
    Cell8=Classification_matrix(tr(k)-1,tc(k)-1); Cell1=Classification_matrix(tr(k)-1,tc(k)); Cell2=Classification_matrix(tr(k)-1,tc(k)+1);...
            Cell3=Classification_matrix(tr(k),tc(k)+1);Cell4=Classification_matrix(tr(k)+1,tc(k)+1);...
            Cell5=Classification_matrix(tr(k)+1,tc(k)); Cell6=Classification_matrix(tr(k)+1,tc(k)-1); Cell7=Classification_matrix(tr(k),tc(k)-1);
    %Putting all 8 cells in a vector matrix
    Classification_boundary=[Cell1; Cell2; Cell3; Cell4; Cell5; Cell6; Cell7; Cell8];
    
    
    
    FPtemp=zeros(8,1);
   

        s=find(Check_boundary==1);
    leng=length(s);
            m=0;
    for fp=1:leng

        if ZT(tr(k),tc(k))>= ZT_boundary(s(fp))
        m=s(fp);
        end
    end 
    if m>0
    FPtemp(m)=100;     
    end
     
    
    
    
    
    if sum(FPtemp)==0
    
        
        m2=0;
        s2=find(ZT_boundary <=ZT(tr(k),tc(k)));
        leng2=length(s2);
        if leng2 >0
    for fp2=1:leng2
           %  if ZT(tr(k),tc(k)) >= ZT_boundary(s)% && Check_Matrix(tr(k),tc(k))==0;%
           
        if isnan(Classification_boundary(s2(fp2)))==1
                    m2=s2(fp2);
        end

    end
    if m2>0
    FPtemp(m2)=100;     
    end
       end
    end
    
    
    
    if sum(FPtemp)>0
    %give the calculated flowpath values in FPtemp to the correct matrix
    FP1(tr(k),tc(k))=FPtemp(1);
    FP2(tr(k),tc(k))=FPtemp(2);
    FP3(tr(k),tc(k))=FPtemp(3);
    FP4(tr(k),tc(k))=FPtemp(4);
    FP5(tr(k),tc(k))=FPtemp(5);
    FP6(tr(k),tc(k))=FPtemp(6);
    FP7(tr(k),tc(k))=FPtemp(7);
    FP8(tr(k),tc(k))=FPtemp(8); 
           Check_Matrix(tr(k),tc(k))=1; 
               Remain_cell2=Remain_cell2 - 1  
    end
  
    
    
end %end if   
end
nnn=nn-Remain_cell2;
    if nnn == 0
       Remain_cell2=0;
    end

nn=Remain_cell2;

end %end of while remain cell2
% PPP1=2
end

Check_Matrix(Check_Matrix>1)=1;
% PPP1=3
% pause
%FL
%n=sum(sum(Check_Matrix ==0));%# of left cells
%nnn=nn-Remain_cell;
  

%end %end while n_change>0
