% ************************************************************
%
%           Culvert creation
%
%   This program is is for connection the the begining point of culvert
%   with the end point and linearly interpolate the elevation for all
%   cells inbetween (breach line)
%   
%          
%   Author: Abdulghani Hasan
%   Date: 30 / 03 / 2010
%
% ************************************************************
function [ZT]=culverts(ZT,nrows,ncols,cellsize,xllcorner,yllcorner)
%Each culvert is of two cells
%Name of culverts pints file is Culvertpoints.txt
%x1 y1    start point culvert 1
%x2 y2    end point culvert 1
%x3 y3    start point culvert 2
%x4 y4    end point culvert 2
%
%

% load text file for culverst points ccordinats

load CulvertsrealmyDEM.txt
INfile=CulvertsrealmyDEM;
 
xcol=INfile(:,1);%column x
ycol=INfile(:,2);%column y
%
%to find the matrix size 
[np trash]=size(INfile); %INfile=total number of coordinates                      	
%numberofculverts=np/2;
YesNo=input('Input a search radius for better culverts ends,Yes=1 NO=2 = ');

if YesNo ==1
SR=input('Input the search radius for searching around each cell/point in meter = ');
end
for j=1:2:np %since each culvert is from two cells (go for odd numbers
%%%%%%
pointsdistance=((xcol(j)- xcol(j+1))^2 + (ycol(j)- ycol(j+1))^2)^0.5;

if YesNo ~=1 %&& pointsdistance >= (2*cellsize)
SR=pointsdistance/2;
end
if pointsdistance >= (2*cellsize)
SRcells = fix((SR/cellsize));%number of search radius cells

if SR < cellsize
  SRcells=0;
end
%
j
TT=xcol(j)
   PL=0;
  %   
    r1=(nrows - fix((ycol(j)-yllcorner)/cellsize));
    c1=fix((xcol(j)-xllcorner)/cellsize)+1
    r2=(nrows - fix((ycol(j+1)-yllcorner)/cellsize));
    c2=fix((xcol(j+1)-xllcorner)/cellsize)+1
    
    %searching for lowest point around cells
    
if SRcells > 0 %search around cells if the search radius is larger than cellsize
    %searching around point 1

    startr=r1-SRcells;
    endr=r1+SRcells;
    startc=c1-SRcells;
    endc=c1+SRcells;
    
    for cc1=startc:endc
       for rr1=startr:endr
           if  cc1 > 0 && rr1 > 0 && cc1 < ncols && rr1 < nrows %chech not out range
           if  ZT(r1,c1) > ZT(rr1,cc1)
               %ZT(r1,c1) = ZT(r,c);
               r1=rr1;
               c1=cc1;
           end    
           end
       end
       
    end

    
    %searching around point 2
    
       startr=r2-SRcells;
    endr=r2+SRcells;
    startc=c2-SRcells;
    endc=c2+SRcells;
    
    for cc2=startc:endc
       for rr2=startr:endr
           if  cc2 > 0 && rr2 > 0 && cc2 < ncols && rr2 < nrows %chech not out range
           %check that the points around the second cell are lower if not
           %change to that point. also chech it should be lower than cell1
           if ZT(rr2,cc2) > ZT(r2,c2) && ZT(rr2,cc2) < ZT(r1,c1) 
              % ZT(r2,c2) = ZT(r,c);
              r2=rr2;
               c2=cc2;
           end
           end
       end
       
    end
end
        
    X1=(c1*cellsize) + xllcorner - 0.5*cellsize;
    X2=(c2*cellsize) + xllcorner - 0.5*cellsize;
    Y1=((nrows-r1)*cellsize) + yllcorner + 0.5*cellsize;
    Y2=((nrows-r2)*cellsize) + yllcorner + 0.5*cellsize;
    
    
    Q1=[X1,Y1];
    Q2=[X2,Y2];
  
    startC=c1;
    endC=c2;
    if c2<c1
      startC=c2; 
      endC=c1;
    end
    
    startR=r1;
    endR=r2;
    if r2<r1
      startR=r2;  
      endR=r1;
    end
    
    
    for cc=startC:endC
       for rr=startR:endR

           xcell= ((cc)*cellsize)+ xllcorner -(0.5*cellsize);
          ycell= (nrows-rr)*cellsize + yllcorner +(0.5*cellsize);
          P=[xcell,ycell];
        
          %check the distance between a point and line
          %if less than or equal 1/2 cellsize then the cell is in culvert
        
          d = abs(det([Q2-Q1;P-Q1]))/norm(Q2-Q1); % for row vectors.
         
          if d<=(0.5*cellsize)
           PL=PL+1;
           rdx(PL)=rr;
           cdx(PL)=cc;
         end
        
        end
    end
 
    %calculate the constant difference change in elevations
    constElvDiff=(abs(ZT(r1,c1) - ZT(r2,c2)))/(PL-1);
    %calculate all distances from the first point
      %to all others that assigned r and c
      for i=1:PL
      Wd(i)=((r1-rdx(i))^2 + (c1-cdx(i))^2)^0.5;
      end
      pointmat=[rdx;cdx;Wd];
      pointmat=pointmat';
      sorrtcells=sortrows(pointmat,3);
      
    if ZT(r1,c1)>ZT(r2,c2)

      for i=2:(PL-1)
T=i-1;
        ZT(sorrtcells(i,1),sorrtcells(i,2))=ZT(r1,c1) - (T*constElvDiff);
      end
      
    end
         %if the second point is heigher than the first
         if ZT(r2,c2)>ZT(r1,c1)
      
        for i=2:(PL-1)
T=i-1;
        ZT(sorrtcells(i,1),sorrtcells(i,2))=ZT(r1,c1) + (T*constElvDiff);
        end     
             
         end
         clear cdx
         clear rdx
         clear Wd
end
end